unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls;

type
  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure dset(S: String);
    function get_comma_next(var inputs: string): string;
    procedure additem(S: String);
    function IntPrime(Value: Integer): Boolean;
    function dateWeekOfYear(D: TDateTime): Integer; { Armin Hanisch }
    function strNiceNum(const S: String) : String;
    function Group(Ch: Char): Char;
    function  comIsCis(const S: String): Boolean;
    procedure strSearchReplace(var S:String; const Source, Dest: String; Options: TSRoptions);
    function RectSetPoint(const TopLeft, BottomRight: TPoint): TRect;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type
  Digits2        = Set of 0..9;
  Letters       = Set of 'A'..'Z';
  TDayOfWeek    = (Sunday,Monday,Tuesday,Wednesday,Thursday,Friday,Saturday);
  TDayOfWeekSet = Set of TDayOfWeek;

{  TIntSet       = Set of Integer; }
  TCharSet      = Set of Char;
  TMonth        = (NoneMonth,January,February,March,April,May,June,July,
                   August,September,October,November,December);

const
  EvenDigits:   Digits2 = [0, 2, 4, 6, 8];
  cDIGITS:      set of Char = ['0', '2', '4'];
  HexDigits:    set of '0'..'z' = ['0'..'9'];

const
  ZERO   = '0';  ONE  = '1';  TWO    = '2';  THREE  = '3';  FOUR  = '4';
  FIVE   = '5';  SIX  = '6';  SEVEN  = '7';  EIGHT  = '8';  NINE  = '9';
  DIGITS          : set of Char = [ZERO..NINE];
  CvTable : array['B'..'Z'] of char = (
    '1', '2', '3', '0', '1',   {'B' .. 'F'}
    '2', '0', '0', '2', '2',   {'G' .. 'K'}
    '4', '5', '5', '0', '1',   {'L' .. 'P'}
    '2', '6', '2', '3', '0',   {'Q' .. 'U'}
    '1', '0', '2', '0', '2' ); {'V' .. 'Z'}

  function TForm1.Group(Ch: Char): Char;
  begin
    if (Ch in ['B' .. 'Z']) and not (Ch In ['E','H','I','O','U','W','Y']) then
       Result:=CvTable[Ch]
    else
       Result:='0';
  end;

procedure TForm1.strSearchReplace(var S:String; const Source, Dest: String; Options: TSRoptions);
var hs,hs1,hs2,hs3: String;
var i,j : integer;

begin
 if  srCase in Options then
  begin
   hs := s;
   hs3 := source;
  end
 else
  begin
   hs:= StrUpper(s);
   hs3 := StrUpper(Source);
  end;
 hs1:= '';
 I:= pos(hs3,hs);
 j := length(hs3);
 while i > 0 do
 begin
   delete(hs,1,i+j-1); {Anfang Rest gendert 8.7.96 KM}
   hs1 := Hs1+copy(s,1,i-1); {Kopieren gendert 8.7.96 KM}
   delete(s,1,i-1); {Lschen bis Anfang posgendert 8.7.96 KM}
   hs2 := copy(s,1,j); {Bis ende pos Sichern}
   delete(s,1,j); {Lschen bis ende Pos}
   if    (not (srWord in Options))
       or (pos(s[1],' .,:;-#''+*?=)(/&%$"!{[]}\~<>|') > 0) then
    begin
     {Quelle durch ziel erstzen}
     hs1 := hs1+dest;
    end
   else
    begin
     hs1 := hs1+hs2;
    end;
   if srall in options then
    I:= pos(hs3,hs)
   else
    i :=0;
  end;
  s:= hs1+s;
end;

function TForm1.RectSetPoint(const TopLeft, BottomRight: TPoint): TRect;
begin
  Result.TopLeft := TopLeft;
  Result.BottomRight := BottomRight;
end;


function TForm1.comIsCis(const S: String): Boolean;
var
  aSt: String;
  PreId,
  PostId: Integer;
begin
  Result:=strContainsU('@compuserve.com',S);     { 28.7.96 sb This is also on CIS }
  if not Result then
     if Pos(',',S) > 0 then
     try
       aSt:=S;
       PreId:=StrToInt(strToken(aSt,','));
       PostId:=StrToInt(aSt);
       Result:=(PreId > 0) and (PostId > 0);
     except
       Result:=False;
     end;
end;

function TForm1.strNiceNum(const S: String) : String;
var
  i    : Integer;
  Seps : set of Char;
begin
  Seps:=[ThousandSeparator,DecimalSeparator];
  Result:= ZERO;
  for i := 1 to Length(S) do
    if S[i] in DIGITS + Seps then
    begin
      if S[i] = ThousandSeparator then
         Result:=Result+DecimalSeparator
      else
         Result:=Result+S[i];
      if S[i] In Seps then Seps:=[];
    end
end;

function TForm1.dateWeekOfYear(D: TDateTime): Integer; { Armin Hanisch }
(*
const
  t1: array[1..7] of ShortInt = ( -1,  0,  1,  2,  3, -3, -2);
  t2: array[1..7] of ShortInt = ( -4,  2,  1,  0, -1, -2, -3);
var
  doy1,
  doy2    : Integer;
  NewYear : TDateTime;
*)
begin
  Result := 0;
(*
  NewYear:=dateBeginOfYear(D);
  doy1 := dateDayofYear(D) + t1[DayOfWeek(NewYear)];
  doy2 := dateDayofYear(D) + t2[DayOfWeek(D)];
  if doy1 <= 0 then
    Result := dateWeekOfYear(NewYear-1)
  else if (doy2 >= dateDayofYear(dateEndOfYear(NewYear))) then
    Result:= 1
  else
    Result:=(doy1-1) div 7+1;
*)
end;


function TForm1.IntPrime(Value: Integer): Boolean;
var
  i : integer;
begin
  Result:=False;
  if Value mod 2 <> 0 then
  begin
    i := 1;
    repeat
      i := i + 2;
      Result:= Value mod i = 0
(*    until Result or ( i > Trunc(sqrt(Value)) );*)
(*    until Result;*)
(*      until (i > 5);*)
      until i > 5;
    Result:= not Result;
  end;
end;


function TForm1.get_comma_next(var inputs: string): string;

begin
  if pos(',',inputs) = 0 then
  begin
    get_comma_next := inputs;
    inputs := '';
    exit;
  end;
  get_comma_next := copy(inputs, 1, pos(',',inputs)-1);
  inputs := copy(inputs, pos(',',inputs)+1, 255);
end;


procedure TForm1.dset(S: String);
var
  S2: String;

begin
  if S[1] = '[' then
    S := copy(S, 2, 255);
  if S[length(S)] = ']' then
    S := copy(S, 1, length(S)-1);

  while length(S) > 0 do
  begin
    S2 := get_comma_next(S);
    additem(s2);
  end;
end;

procedure Tform1.additem(S: String);

begin
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  (* FC *)
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  junk: integer;

begin
  junk := StringGrid1.ColCount;
  junk := StringGrid1.RowCount;
  junk := StringGrid1.DefaultColWidth;
  junk := StringGrid1.DefaultRowHeight;
  StringGrid1.ColCount := 2;
  StringGrid1.RowCount := 10;
  StringGrid1.DefaultColWidth := 80;
  StringGrid1.DefaultRowHeight := 40;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
   x: Integer;

begin
  for x := 1 to 10 do
      StringGrid1.Cells[0, x] := inttostr(x);

  for x := 1 to 10 do
      StringGrid1.Cells[1, x] := 'Col1:'+inttostr(x);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   J: TDayOfWeek;
   i: integer;

begin
  {J := Sunday;}

  i := 6;

  if (i in EvenDigits) then
  begin
    showmessage('i is even');
  end;

  if ((i) in EvenDigits) then
  begin
    showmessage('i is even');
  end;

  if (i in [3,6,9]) then
  begin
    showmessage('i is a multiple of 3');
  end;
end;

end.
